%define basen qcas
%define major 1
%define libname %mklibname %{basen} %{major}
%define develname %mklibname %{basen} -d

Name:          qcas
Summary:       Qt5 GUI application for Giac
Version:       0.5.3
Release:       %mkrel 1
License:       GPLv3+
URL:           http://webusers.imj-prg.fr/~frederic.han/qcas
Source0:       https://git.tuxfamily.org/qcas/qcas.git/snapshot/%{name}-%{version}.zip
Group:         Sciences/Mathematics
Source1:       %{name}.desktop
Source2:       %{name}.appdata.xml
Source3:       %{name}-qt4.desktop
BuildRequires: appstream-glib
BuildRequires: lib64giac-devel
BuildRequires: lib64gmp-devel
BuildRequires: lib64qt5core-devel
BuildRequires: lib64qt5gui-devel
BuildRequires: lib64qt5help-devel
BuildRequires: lib64qt5keychain-devel
BuildRequires: lib64qt5labstemplates-devel
BuildRequires: lib64qt5location-devel
BuildRequires: lib64qt5multimedia-devel
BuildRequires: lib64qt5multimediagsttools-devel
BuildRequires: lib64qt5multimediaquick-devel
BuildRequires: lib64qt5multimediawidgets-devel
BuildRequires: lib64qt5networkauth-devel
BuildRequires: lib64qt5nfc-devel
BuildRequires: lib64qt5packetprotocol-static-devel
BuildRequires: lib64qt5positioning-devel
BuildRequires: lib64qt5purchasing-devel
BuildRequires: lib64qt5qml-devel
BuildRequires: lib64qt5qt3d-devel
BuildRequires: lib64qt5quick-devel
BuildRequires: lib64qt5quickparticles-devel
BuildRequires: lib64qt5quickshapes-devel
BuildRequires: lib64qt5quicktemplates-devel
BuildRequires: lib64qt5quickwidgets-devel
BuildRequires: lib64qt5remoteobjects-devel
BuildRequires: lib64qt5script-devel
BuildRequires: lib64qt5scripttools-devel
BuildRequires: lib64qt5scxml-devel
BuildRequires: lib64qt5sensors-devel
BuildRequires: lib64qt5serialbus-devel
BuildRequires: lib64qt5serialport-devel
BuildRequires: lib64qt5svg5
BuildRequires: lib64qt5svg-devel
BuildRequires: lib64qt5texttospeech-devel
BuildRequires: lib64qt5virtualkeyboard-devel
BuildRequires: lib64qt5waylandclient-devel
BuildRequires: lib64qt5webchannel-devel
BuildRequires: lib64qt5webengine-devel
BuildRequires: lib64qt5webkit-devel
BuildRequires: lib64qt5webkitwidgets-devel
BuildRequires: lib64qt5websockets-devel
BuildRequires: lib64qt5webview-devel
BuildRequires: lib64qt5widgets5
BuildRequires: lib64qt5widgets-devel
BuildRequires: lib64qt5x11extras-devel
BuildRequires: lib64qt5xml5
BuildRequires: lib64qt5xml-devel
BuildRequires: lib64qt5xmlpatterns-devel

Requires: giac
Requires: %{libname}      

%description
Minimal Qt5 interface for Giac.

%package        qt4
Summary:        Qt4 GUI application for Giac
Group:          Sciences/Mathematics
Requires:       %{libname}
BuildRequires:  lib64qt4-devel

%description    qt4
Minimal Qt4 interface for Giac.

%package        -n %{libname}
Summary:        Private library of Qcas
Group:          System/Libraries
Requires:       qcas-data

%description    -n %{libname}
Private library of Qcas.

%package        -n %{develname}
Summary:        Development files of lib%{name}
Group:          Development/Libraries
Requires:       %{libname} = %{version}-%{release}

%description    -n %{develname}
This package contains libraries and header files for developing
applications that use lib%{name}.
#######################################

%package        data
Summary:        Data files of Qcas
Requires:       giac-doc
BuildArch:      noarch
%description    data
Data files of Qcas.

%prep
%setup -q -n %{name}-%{version}
rm -rf libtommath

%build
mkdir build && pushd build
%{qmake_qt5} ../%{name}.pro \
 QMAKE_CFLAGS_RELEASE="$RPM_OPT_FLAGS" \
 QMAKE_CXXFLAGS_RELEASE="$RPM_OPT_FLAGS" \
 QMAKE_LFLAGS="$RPM_LD_FLAGS"
%make_build

sed -e 's|CONFIG+=staticlib|#CONFIG+=staticlib|g' -i ../lib%{name}.pro
%{qmake_qt5} ../lib%{name}.pro QMAKE_STRIP=echo
%make_build
popd

mkdir build2 && pushd build2
%{qmake_qt4} ../%{name}.pro \
 QMAKE_CFLAGS_RELEASE="$RPM_OPT_FLAGS" \
 QMAKE_CXXFLAGS_RELEASE="$RPM_OPT_FLAGS" \
 QMAKE_LFLAGS="$RPM_LD_FLAGS"
%make_build
popd

%install
pushd build
mkdir -p %{buildroot}%{_bindir}
install -p -m 755 ./qcas %{buildroot}%{_bindir}

mkdir -p %{buildroot}%{_libdir}
install -p -m 755 ./lib%{name}.* %{buildroot}%{_libdir}
ln -sf %{_libdir}/libqcas.so.1.0.0 %{buildroot}%{_libdir}/libqcas.so
ln -sf %{_libdir}/libqcas.so.1.0.0 %{buildroot}%{_libdir}/libqcas.so.1
ln -sf %{_libdir}/libqcas.so.1.0.0 %{buildroot}%{_libdir}/libqcas.so.1.0

mkdir -p %{buildroot}%{_includedir}/lib%{name}
install -pm 644 ui_MainWindow.h \
 ../qt/MainWindow.h \
 ../qt/output.h \
 ../qt/CasManager.h \
 ../qt/geometry.h \
 ../qt/config.h \
 ../qt/giacpy.h \
 ../qt/sizeof_void_p.h %{buildroot}%{_includedir}/lib%{name}/
mkdir -p %{buildroot}%{_includedir}/lib%{name}/gui
install -pm 644 ../qt/gui/WizardMatrix.h \
 ../qt/gui/WizardEquation.h \
 ../qt/gui/WizardCatalog.h \
 ../qt/gui/WizardAlgo.h \
 ../qt/gui/spreadsheet.h \
 ../qt/gui/qtmmlwidget.h \
 ../qt/gui/FormalSheet.h \
 ../qt/gui/FormalLineWidgets.h \
 ../qt/gui/FormalLine.h \
 ../qt/gui/CentralTabWidget.h \
 ../qt/gui/prefdialog.h \
 ../qt/gui/plotfunctiondialog.h  %{buildroot}%{_includedir}/lib%{name}/gui/
popd
pushd build2
mkdir -p %{buildroot}%{_bindir}
install -p -m 755 ./qcas %{buildroot}%{_bindir}/qcas-qt4
popd
mkdir -p %{buildroot}%{_datadir}/qcas
cp -a qt/doc qt/lang qt/images %{buildroot}%{_datadir}/qcas
install -pm 644 qt/aide_cas %{buildroot}%{_datadir}/qcas
install -pm 644 qt/aide_cas %{buildroot}%{_datadir}/qcas/doc

mkdir -p %{buildroot}%{_datadir}/pixmaps
install -p -m 644 qt/images/icon.png %{buildroot}%{_datadir}/pixmaps/qcas.png

# Install desktop file
desktop-file-install %{SOURCE1} %{buildroot}%{_datadir}/applications/%{name}.desktop
desktop-file-install %{SOURCE3} %{buildroot}%{_datadir}/applications/%{name}-qt4.desktop

# Install appdata file
mkdir -p %{buildroot}%{_datadir}/metainfo
install -pm 644 %{SOURCE2} %{buildroot}%{_datadir}/metainfo/
appstream-util validate-relax --nonet %{buildroot}%{_datadir}/metainfo/*.appdata.xml


%files
%{_bindir}/%{name}
%{_datadir}/applications/%{name}.desktop

%files qt4
%{_bindir}/%{name}-qt4
%{_datadir}/applications/%{name}-qt4.desktop

%files -n %{libname}
%{_libdir}/libqcas.so.*

%files -n %{develname}
%{_libdir}/libqcas.so
%{_includedir}/lib%{name}/

%files data
%{_datadir}/%{name}/
%{_datadir}/pixmaps/%{name}.png
%{_datadir}/metainfo/%{name}.appdata.xml

%changelog
* Mon Jan 20 2020 tex - 0.5.3-1pclos2020
- create
